package common.block.artificial;

import common.block.Block;
import common.block.Material;
import common.color.DyeColor;
import common.item.CheatTab;
import common.model.Model;
import common.model.ModelProvider;
import common.model.Transforms;
import common.util.BlockPos;
import common.util.Facing;
import common.world.IWorldAccess;
import common.world.State;
import common.world.World;

public class BlockCarpet extends Block
{
	public static final BlockCarpet[] CARPETS = new BlockCarpet[DyeColor.values().length];
	
    private final DyeColor color;
    
    public static BlockCarpet getByColor(DyeColor color) {
    	return CARPETS[color.getMetadata()];
    }

    public BlockCarpet(DyeColor color)
    {
        super(Material.FLEECE);
        this.color = color;
        this.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.0625F, 1.0F);
        this.setTab(CheatTab.DECORATION);
        this.setBlockBoundsFromMeta();
        this.setFlammable(60, 20);
        CARPETS[color.ordinal()] = this;
    }
	
	public DyeColor getColor() {
		return this.color;
	}

    /**
     * Used to determine ambient occlusion and culling when rebuilding chunks for render
     */
    public boolean isOpaqueCube()
    {
        return false;
    }

    public boolean isFullCube()
    {
        return false;
    }

    /**
     * Sets the block's bounds for rendering it as an item
     */
    public void setBlockBoundsForItemRender()
    {
        this.setBlockBoundsFromMeta();
    }

    public void setBlockBoundsBasedOnState(IWorldAccess worldIn, BlockPos pos)
    {
        this.setBlockBoundsFromMeta();
    }

    private void setBlockBoundsFromMeta()
    {
        int i = 0;
        float f = (float)(1 * (1 + i)) / 16.0F;
        this.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
    }

    public boolean canPlaceBlockAt(World worldIn, BlockPos pos)
    {
        return super.canPlaceBlockAt(worldIn, pos) && this.canBlockStay(worldIn, pos);
    }

    /**
     * Called when a neighboring block changes.
     */
    public void onNeighborBlockChange(World worldIn, BlockPos pos, State state, Block neighborBlock)
    {
        this.checkForDrop(worldIn, pos, state);
    }

    private boolean checkForDrop(World worldIn, BlockPos pos, State state)
    {
        if (!this.canBlockStay(worldIn, pos))
        {
            this.dropBlockAsItem(worldIn, pos, state, 0);
            worldIn.setBlockToAir(pos);
            return false;
        }
        else
        {
            return true;
        }
    }

    private boolean canBlockStay(World worldIn, BlockPos pos)
    {
        return !worldIn.isAirBlock(pos.down());
    }

    public boolean shouldSideBeRendered(IWorldAccess worldIn, BlockPos pos, Facing side)
    {
        return side == Facing.UP ? true : super.shouldSideBeRendered(worldIn, pos, side);
    }

    public Transforms getTransform() {
    	return Transforms.LAYER;
    }

    public Model getModel(ModelProvider provider, String name, State state) {
    	return provider.getModel(this.color.getName() + "_wool").add(0, 0, 0, 16, 1, 16).nswe().uv(0, 15, 16, 16).d().u().noCull();
    }
}
